image: docker:git

services:
  - name: docker:stable-dind
    command: [ "--tls=false" ]

variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_TLS_CERTDIR: ""
  DOCKER_DRIVER: overlay2
  BUILDX_VERSION: "v0.7.0"
  BUILDX_ARCH: "linux-amd64"
  PLATFORMS: "linux/arm64,linux/amd64"
  BUILDX_URL: https://github.com/docker/buildx/releases/download/$BUILDX_VERSION/buildx-$BUILDX_VERSION.$BUILDX_ARCH

stages:
  - build
  - package
  - version

before_script:
  - export GRADLE_USER_HOME=`pwd`/.gradle

cache:
  paths:
    - .gradle/wrapper

gradle-build:
  stage: build
  image: openjdk:17-jdk
  script: "./gradlew build -x test"
  artifacts:
    paths:
      - build/libs/*.jar

docker-test:
  stage: package
  needs:
    - job: gradle-build
      artifacts: true
  except:
    - master
    - tags
  before_script:
    - wget -O /usr/bin/docker-buildx $BUILDX_URL
    - chmod +x /usr/bin/docker-buildx
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker-buildx create --use
    - docker-buildx build --platform $PLATFORMS .

docker-latest:
  stage: package
  needs:
    - job: gradle-build
      artifacts: true
  only:
    - master
  before_script:
    - wget -O /usr/bin/docker-buildx $BUILDX_URL
    - chmod +x /usr/bin/docker-buildx
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker-buildx create --use
    - docker-buildx build --platform $PLATFORMS -t $CI_REGISTRY_IMAGE:latest --push .

docker-version:
  stage: package
  needs:
    - job: gradle-build
      artifacts: true
  only:
    - tags
  before_script:
    - wget -O /usr/bin/docker-buildx $BUILDX_URL
    - chmod +x /usr/bin/docker-buildx
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker-buildx create --use
    - docker-buildx build --platform $PLATFORMS -t $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG --push .